﻿using Infragistics.Windows;
using KB1390_DragDropSample_TwoControls.Models;
using KB1390_DragDropSample_TwoControls.ViewModels;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace KB1390_DragDropSample_TwoControls
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public TaskViewModel VM { get; set; } = new TaskViewModel();

        public MainWindow()
        {
            InitializeComponent();

            this.DataContext = this.VM;
        }

        private void DragSource_Drop(object sender, Infragistics.DragDrop.DropEventArgs e)
        {
            // ドラッグ元のUI要素（今回の場合Border）と紐づいているTaskItemを取り出す。
            Border sourcePanel = e.DragSource as Border;
            TaskItem sourceTask = sourcePanel.DataContext as TaskItem;

            // ドラッグ元のListViewを取得
            // https://jp.infragistics.com/help/wpf/infragisticswpf~infragistics.windows.utilities~getancestorfromtype(dependencyobject,type,boolean)
            ListView sourceListView = Utilities.GetAncestorFromType(sourcePanel, typeof(ListView), false) as ListView;

            // ドロップ先のListViewを取得
            ListView targetListView = e.DropTarget as ListView;

            // ドラッグ元とドロップ先のListViewにバインドされているコレクションを取得する。
            ObservableCollection<TaskItem> sourceTasks = sourceListView.ItemsSource as ObservableCollection<TaskItem>;
            ObservableCollection<TaskItem> targetTasks = targetListView.ItemsSource as ObservableCollection<TaskItem>;

            // ドラッグされたTaskItemをドラッグ元のコレクションから削除し、ドロップ先のコレクションに追加する。
            sourceTasks.Remove(sourceTask);
            targetTasks.Add(sourceTask);
        }
    }
}
